<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>pyxmpp.clientstream.ClientStream</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="pyxmpp-module.html">Package&nbsp;pyxmpp</a> ::
        <a href="pyxmpp.clientstream-module.html">Module&nbsp;clientstream</a> ::
        Class&nbsp;ClientStream
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
        <tr><td align="right"><span class="options">[<a href="javascript:void(0);" class="privatelink"
    onclick="toggle_private();">hide&nbsp;private</a>]</span></td></tr>
      </table>
    </td>
  </tr>
</table>
<!-- ==================== CLASS DESCRIPTION ==================== -->
<h1 class="epydoc">Class ClientStream</h1><p class="nomargin-top"><span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream">source&nbsp;code</a></span></p>
<pre class="base-tree">
           <a href="pyxmpp.streamtls.StreamTLSMixIn-class.html">streamtls.StreamTLSMixIn</a> --+    
                                      |    
      <a href="pyxmpp.sasl.core.PasswordManager-class.html">sasl.core.PasswordManager</a> --+   |    
                                  |   |    
         <a href="pyxmpp.streamsasl.StreamSASLMixIn-class.html">streamsasl.StreamSASLMixIn</a> --+    
                                      |    
<a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html">stanzaprocessor.StanzaProcessor</a> --+   |    
                                  |   |    
         <a href="pyxmpp.xmlextra.StreamHandler-class.html">xmlextra.StreamHandler</a> --+   |    
                                  |   |    
              <a href="pyxmpp.streambase.StreamBase-class.html">streambase.StreamBase</a> --+    
                                      |    
                          <a href="pyxmpp.stream.Stream-class.html">stream.Stream</a> --+
                                          |
                                         <strong class="uidshort">ClientStream</strong>
</pre>

<dl><dt>Known Subclasses:</dt>
<dd>
      <ul class="subclass-list">
<li><a href="pyxmpp.jabber.clientstream.LegacyClientStream-class.html">jabber.clientstream.LegacyClientStream</a></li>  </ul>
</dd></dl>

<hr />
<p>Handles XMPP-IM client connection stream.</p>
<p>Both client and server side of the connection is supported. This class handles
client SASL authentication, authorisation and resource binding.</p>
<p>This class is not ready for handling of legacy Jabber servers, as it doesn't
provide legacy authentication.</p>

<!-- ==================== INSTANCE METHODS ==================== -->
<a name="section-InstanceMethods"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Instance Methods</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-InstanceMethods"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.clientstream.ClientStream-class.html#__init__" class="summary-sig-name">__init__</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">jid</span>,
        <span class="summary-sig-arg">password</span>=<span class="summary-sig-default">None</span>,
        <span class="summary-sig-arg">server</span>=<span class="summary-sig-default">None</span>,
        <span class="summary-sig-arg">port</span>=<span class="summary-sig-default">None</span>,
        <span class="summary-sig-arg">auth_methods</span>=<span class="summary-sig-default"><code class="variable-group">(</code><code class="variable-quote">'</code><code class="variable-string">sasl:DIGEST-MD5</code><code class="variable-quote">'</code><code class="variable-group">)</code></span>,
        <span class="summary-sig-arg">tls_settings</span>=<span class="summary-sig-default">None</span>,
        <span class="summary-sig-arg">keepalive</span>=<span class="summary-sig-default">0</span>,
        <span class="summary-sig-arg">owner</span>=<span class="summary-sig-default">None</span>)</span><br />
      Initialize the ClientStream object.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream.__init__">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.clientstream.ClientStream-class.html#_connect" class="summary-sig-name" onclick="show_private();">_connect</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">server</span>=<span class="summary-sig-default">None</span>,
        <span class="summary-sig-arg">port</span>=<span class="summary-sig-default">None</span>)</span><br />
      Same as <a href="pyxmpp.clientstream.ClientStream-class.html#connect" class="link">ClientStream.connect</a> but assume <a href="pyxmpp.stream.Stream-class.html#lock" class="link">self.lock</a> is acquired.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream._connect">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.clientstream.ClientStream-class.html#_get_stream_features" class="summary-sig-name" onclick="show_private();">_get_stream_features</a>(<span class="summary-sig-arg">self</span>)</span><br />
      Include resource binding feature in the stream features list.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream._get_stream_features">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.clientstream.ClientStream-class.html#_post_connect" class="summary-sig-name" onclick="show_private();">_post_connect</a>(<span class="summary-sig-arg">self</span>)</span><br />
      Initialize authentication when the connection is established
and we are the initiator.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream._post_connect">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.clientstream.ClientStream-class.html#_reset" class="summary-sig-name" onclick="show_private();">_reset</a>(<span class="summary-sig-arg">self</span>)</span><br />
      Reset <a href="pyxmpp.clientstream.ClientStream-class.html" class="link">ClientStream</a> object state, making the object ready to handle
new connections.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream._reset">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.clientstream.ClientStream-class.html#_try_auth" class="summary-sig-name" onclick="show_private();">_try_auth</a>(<span class="summary-sig-arg">self</span>)</span><br />
      Try to authenticate using the first one of allowed authentication
methods left.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream._try_auth">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.clientstream.ClientStream-class.html#accept" class="summary-sig-name">accept</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">sock</span>)</span><br />
      Accept an incoming client connection.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream.accept">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code class="link">bool</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.clientstream.ClientStream-class.html#check_authzid" class="summary-sig-name">check_authzid</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">authzid</span>,
        <span class="summary-sig-arg">extra_info</span>=<span class="summary-sig-default">None</span>)</span><br />
      Check authorization id provided by the client.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream.check_authzid">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code class="link">unicode</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.clientstream.ClientStream-class.html#choose_realm" class="summary-sig-name">choose_realm</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">realm_list</span>)</span><br />
      Choose authentication realm from the list provided by the server.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream.choose_realm">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.clientstream.ClientStream-class.html#connect" class="summary-sig-name">connect</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">server</span>=<span class="summary-sig-default">None</span>,
        <span class="summary-sig-arg">port</span>=<span class="summary-sig-default">None</span>)</span><br />
      Establish a client connection to a server.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream.connect">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.clientstream.ClientStream-class.html#do_bind" class="summary-sig-name">do_bind</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">stanza</span>)</span><br />
      Do the resource binding requested by a client connected.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream.do_bind">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.clientstream.ClientStream-class.html#fix_in_stanza" class="summary-sig-name">fix_in_stanza</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">stanza</span>)</span><br />
      Fix an incoming stanza.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream.fix_in_stanza">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.clientstream.ClientStream-class.html#fix_out_stanza" class="summary-sig-name">fix_out_stanza</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">stanza</span>)</span><br />
      Fix outgoing stanza.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream.fix_out_stanza">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">(<code class="link">unicode</code>,`str`)</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.clientstream.ClientStream-class.html#get_password" class="summary-sig-name">get_password</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">username</span>,
        <span class="summary-sig-arg">realm</span>=<span class="summary-sig-default">None</span>,
        <span class="summary-sig-arg">acceptable_formats</span>=<span class="summary-sig-default"><code class="variable-group">(</code><code class="variable-quote">'</code><code class="variable-string">plain</code><code class="variable-quote">'</code><code class="variable-group">)</code></span>)</span><br />
      Get a user password for the SASL authentication.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream.get_password">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><code class="link">list</code> of <code class="link">unicode</code></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.clientstream.ClientStream-class.html#get_realms" class="summary-sig-name">get_realms</a>(<span class="summary-sig-arg">self</span>)</span><br />
      Get realms available for client authentication.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream.get_realms">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.clientstream.ClientStream-class.html#get_serv_host" class="summary-sig-name">get_serv_host</a>(<span class="summary-sig-arg">self</span>)</span><br />
      Get the service host name for SASL authentication.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream.get_serv_host">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.clientstream.ClientStream-class.html#get_serv_name" class="summary-sig-name">get_serv_name</a>(<span class="summary-sig-arg">self</span>)</span><br />
      Get the service name for SASL authentication.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream.get_serv_name">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.clientstream.ClientStream-class.html#get_serv_type" class="summary-sig-name">get_serv_type</a>(<span class="summary-sig-arg">self</span>)</span><br />
      Get the server name for SASL authentication.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream.get_serv_type">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
  <tr>
    <td colspan="2" class="summary">
    <div class="private">    <p class="indent-wrapped-lines"><b>Inherited from <code><a href="pyxmpp.stream.Stream-class.html">stream.Stream</a></code></b> (private):
      <code><a href="pyxmpp.stream.Stream-class.html#_got_features" onclick="show_private();">_got_features</a></code>,
      <code><a href="pyxmpp.stream.Stream-class.html#_make_stream_features" onclick="show_private();">_make_stream_features</a></code>,
      <code><a href="pyxmpp.stream.Stream-class.html#_process_node" onclick="show_private();">_process_node</a></code>
      </p></div>
    <p class="indent-wrapped-lines"><b>Inherited from <code><a href="pyxmpp.streamtls.StreamTLSMixIn-class.html">streamtls.StreamTLSMixIn</a></code></b>:
      <code><a href="pyxmpp.streamtls.StreamTLSMixIn-class.html#get_tls_connection">get_tls_connection</a></code>,
      <code><a href="pyxmpp.streamtls.StreamTLSMixIn-class.html#tls_is_certificate_valid">tls_is_certificate_valid</a></code>
      </p>
    <div class="private">    <p class="indent-wrapped-lines"><b>Inherited from <code><a href="pyxmpp.streamtls.StreamTLSMixIn-class.html">streamtls.StreamTLSMixIn</a></code></b> (private):
      <code><a href="pyxmpp.streamtls.StreamTLSMixIn-class.html#_handle_tls_features" onclick="show_private();">_handle_tls_features</a></code>,
      <code><a href="pyxmpp.streamtls.StreamTLSMixIn-class.html#_make_stream_tls_features" onclick="show_private();">_make_stream_tls_features</a></code>,
      <code><a href="pyxmpp.streamtls.StreamTLSMixIn-class.html#_make_tls_connection" onclick="show_private();">_make_tls_connection</a></code>,
      <code><a href="pyxmpp.streamtls.StreamTLSMixIn-class.html#_process" onclick="show_private();">_process</a></code>,
      <code><a href="pyxmpp.streamtls.StreamTLSMixIn-class.html#_process_node_tls" onclick="show_private();">_process_node_tls</a></code>,
      <code><a href="pyxmpp.streamtls.StreamTLSMixIn-class.html#_process_tls_node" onclick="show_private();">_process_tls_node</a></code>,
      <code><a href="pyxmpp.streamtls.StreamTLSMixIn-class.html#_read" onclick="show_private();">_read</a></code>,
      <code><a href="pyxmpp.streamtls.StreamTLSMixIn-class.html#_read_tls" onclick="show_private();">_read_tls</a></code>,
      <code><a href="pyxmpp.streamtls.StreamTLSMixIn-class.html#_request_tls" onclick="show_private();">_request_tls</a></code>,
      <code><a href="pyxmpp.streamtls.StreamTLSMixIn-class.html#_reset_tls" onclick="show_private();">_reset_tls</a></code>,
      <code><a href="pyxmpp.streamtls.StreamTLSMixIn-class.html#_write_raw" onclick="show_private();">_write_raw</a></code>
      </p></div>
    <div class="private">    <p class="indent-wrapped-lines"><b>Inherited from <code><a href="pyxmpp.streamsasl.StreamSASLMixIn-class.html">streamsasl.StreamSASLMixIn</a></code></b> (private):
      <code><a href="pyxmpp.streamsasl.StreamSASLMixIn-class.html#_handle_sasl_features" onclick="show_private();">_handle_sasl_features</a></code>,
      <code><a href="pyxmpp.streamsasl.StreamSASLMixIn-class.html#_make_stream_sasl_features" onclick="show_private();">_make_stream_sasl_features</a></code>,
      <code><a href="pyxmpp.streamsasl.StreamSASLMixIn-class.html#_process_node_sasl" onclick="show_private();">_process_node_sasl</a></code>,
      <code><a href="pyxmpp.streamsasl.StreamSASLMixIn-class.html#_process_sasl_abort" onclick="show_private();">_process_sasl_abort</a></code>,
      <code><a href="pyxmpp.streamsasl.StreamSASLMixIn-class.html#_process_sasl_auth" onclick="show_private();">_process_sasl_auth</a></code>,
      <code><a href="pyxmpp.streamsasl.StreamSASLMixIn-class.html#_process_sasl_challenge" onclick="show_private();">_process_sasl_challenge</a></code>,
      <code><a href="pyxmpp.streamsasl.StreamSASLMixIn-class.html#_process_sasl_failure" onclick="show_private();">_process_sasl_failure</a></code>,
      <code><a href="pyxmpp.streamsasl.StreamSASLMixIn-class.html#_process_sasl_node" onclick="show_private();">_process_sasl_node</a></code>,
      <code><a href="pyxmpp.streamsasl.StreamSASLMixIn-class.html#_process_sasl_response" onclick="show_private();">_process_sasl_response</a></code>,
      <code><a href="pyxmpp.streamsasl.StreamSASLMixIn-class.html#_process_sasl_success" onclick="show_private();">_process_sasl_success</a></code>,
      <code><a href="pyxmpp.streamsasl.StreamSASLMixIn-class.html#_reset_sasl" onclick="show_private();">_reset_sasl</a></code>,
      <code><a href="pyxmpp.streamsasl.StreamSASLMixIn-class.html#_sasl_authenticate" onclick="show_private();">_sasl_authenticate</a></code>
      </p></div>
    <p class="indent-wrapped-lines"><b>Inherited from <code><a href="pyxmpp.sasl.core.PasswordManager-class.html">sasl.core.PasswordManager</a></code></b>:
      <code><a href="pyxmpp.sasl.core.PasswordManager-class.html#check_password">check_password</a></code>,
      <code><a href="pyxmpp.sasl.core.PasswordManager-class.html#generate_nonce">generate_nonce</a></code>
      </p>
    <p class="indent-wrapped-lines"><b>Inherited from <code><a href="pyxmpp.streambase.StreamBase-class.html">streambase.StreamBase</a></code></b>:
      <code><a href="pyxmpp.streambase.StreamBase-class.html#__del__">__del__</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#bind">bind</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#check_to">check_to</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#close">close</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#connected">connected</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#disconnect">disconnect</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#error">error</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#fileno">fileno</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#generate_id">generate_id</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#idle">idle</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#loop">loop</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#loop_iter">loop_iter</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#process">process</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#process_stream_error">process_stream_error</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#send">send</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#stanza">stanza</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#stanza_start">stanza_start</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#state_change">state_change</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#stream_end">stream_end</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#stream_start">stream_start</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#write_raw">write_raw</a></code>
      </p>
    <div class="private">    <p class="indent-wrapped-lines"><b>Inherited from <code><a href="pyxmpp.streambase.StreamBase-class.html">streambase.StreamBase</a></code></b> (private):
      <code><a href="pyxmpp.streambase.StreamBase-class.html#_accept" onclick="show_private();">_accept</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#_bind_error" onclick="show_private();">_bind_error</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#_bind_success" onclick="show_private();">_bind_success</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#_close" onclick="show_private();">_close</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#_connect_socket" onclick="show_private();">_connect_socket</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#_disconnect" onclick="show_private();">_disconnect</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#_feed_reader" onclick="show_private();">_feed_reader</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#_idle" onclick="show_private();">_idle</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#_loop_iter" onclick="show_private();">_loop_iter</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#_make_reader" onclick="show_private();">_make_reader</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#_post_auth" onclick="show_private();">_post_auth</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#_process_stream_node" onclick="show_private();">_process_stream_node</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#_restart_stream" onclick="show_private();">_restart_stream</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#_send" onclick="show_private();">_send</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#_send_stream_end" onclick="show_private();">_send_stream_end</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#_send_stream_error" onclick="show_private();">_send_stream_error</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#_send_stream_features" onclick="show_private();">_send_stream_features</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#_send_stream_start" onclick="show_private();">_send_stream_start</a></code>,
      <code><a href="pyxmpp.streambase.StreamBase-class.html#_write_node" onclick="show_private();">_write_node</a></code>
      </p></div>
    <p class="indent-wrapped-lines"><b>Inherited from <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html">stanzaprocessor.StanzaProcessor</a></code></b>:
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#process_iq">process_iq</a></code>,
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#process_message">process_message</a></code>,
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#process_presence">process_presence</a></code>,
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#process_response">process_response</a></code>,
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#process_stanza">process_stanza</a></code>,
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#route_stanza">route_stanza</a></code>,
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#set_iq_get_handler">set_iq_get_handler</a></code>,
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#set_iq_set_handler">set_iq_set_handler</a></code>,
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#set_message_handler">set_message_handler</a></code>,
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#set_presence_handler">set_presence_handler</a></code>,
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#set_response_handlers">set_response_handlers</a></code>,
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#unset_iq_get_handler">unset_iq_get_handler</a></code>,
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#unset_iq_set_handler">unset_iq_set_handler</a></code>
      </p>
    <div class="private">    <p class="indent-wrapped-lines"><b>Inherited from <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html">stanzaprocessor.StanzaProcessor</a></code></b> (private):
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#_set_response_handlers" onclick="show_private();">_set_response_handlers</a></code>
      </p></div>
    <p class="indent-wrapped-lines"><b>Inherited from <code><a href="pyxmpp.xmlextra.StreamHandler-class.html">xmlextra.StreamHandler</a></code></b>:
      <code><a href="pyxmpp.xmlextra.StreamHandler-class.html#warning">warning</a></code>
      </p>
    <div class="private">    <p class="indent-wrapped-lines"><b>Inherited from <code><a href="pyxmpp.xmlextra.StreamHandler-class.html">xmlextra.StreamHandler</a></code></b> (private):
      <code><a href="pyxmpp.xmlextra.StreamHandler-class.html#_stanza" onclick="show_private();">_stanza</a></code>,
      <code><a href="pyxmpp.xmlextra.StreamHandler-class.html#_stream_end" onclick="show_private();">_stream_end</a></code>,
      <code><a href="pyxmpp.xmlextra.StreamHandler-class.html#_stream_start" onclick="show_private();">_stream_start</a></code>
      </p></div>
    </td>
  </tr>
</table>
<!-- ==================== INSTANCE VARIABLES ==================== -->
<a name="section-InstanceVariables"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Instance Variables</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-InstanceVariables"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">: <code class="link">list</code> of <code class="link">str</code></span>
    </td><td class="summary">
        <a name="auth_methods"></a><span class="summary-name">auth_methods</span><br />
      : allowed authentication methods.
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">: <a href="pyxmpp.jid.JID-class.html" class="link">pyxmpp.JID</a></span>
    </td><td class="summary">
        <a href="pyxmpp.clientstream.ClientStream-class.html#my_jid" class="summary-name">my_jid</a><br />
      : requested local JID.
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">: <code class="link">str</code></span>
    </td><td class="summary">
        <a name="password"></a><span class="summary-name">password</span><br />
      : user's password.
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">: <code class="link">int</code></span>
    </td><td class="summary">
        <a name="port"></a><span class="summary-name">port</span><br />
      : port number to use.
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">: <code class="link">str</code></span>
    </td><td class="summary">
        <a name="server"></a><span class="summary-name">server</span><br />
      : server to use.
    </td>
  </tr>
  <tr>
    <td colspan="2" class="summary">
    <p class="indent-wrapped-lines"><b>Inherited from <code><a href="pyxmpp.stream.Stream-class.html">stream.Stream</a></code></b>:
      <code><a href="pyxmpp.stream.Stream-class.html#features">features</a></code>,
      <code><a href="pyxmpp.stream.Stream-class.html#initiator">initiator</a></code>,
      <code><a href="pyxmpp.stream.Stream-class.html#lock">lock</a></code>,
      <code><a href="pyxmpp.stream.Stream-class.html#me">me</a></code>,
      <code><a href="pyxmpp.stream.Stream-class.html#peer">peer</a></code>,
      <code><a href="pyxmpp.stream.Stream-class.html#process_all_stanzas">process_all_stanzas</a></code>,
      <code><a href="pyxmpp.stream.Stream-class.html#tls">tls</a></code>
      </p>
    <div class="private">    <p class="indent-wrapped-lines"><b>Inherited from <code><a href="pyxmpp.stream.Stream-class.html">stream.Stream</a></code></b> (private):
      <code><a href="pyxmpp.stream.Stream-class.html#_reader" onclick="show_private();">_reader</a></code>
      </p></div>
    <p class="indent-wrapped-lines"><b>Inherited from <code><a href="pyxmpp.streambase.StreamBase-class.html">streambase.StreamBase</a></code></b>:
      <code><a href="pyxmpp.streambase.StreamBase-class.html#owner">owner</a></code>
      </p>
    </td>
  </tr>
</table>
<!-- ==================== METHOD DETAILS ==================== -->
<a name="section-MethodDetails"></a>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Method Details</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-MethodDetails"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
</table>
<a name="__init__"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">__init__</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">jid</span>,
        <span class="sig-arg">password</span>=<span class="sig-default">None</span>,
        <span class="sig-arg">server</span>=<span class="sig-default">None</span>,
        <span class="sig-arg">port</span>=<span class="sig-default">None</span>,
        <span class="sig-arg">auth_methods</span>=<span class="sig-default"><code class="variable-group">(</code><code class="variable-quote">'</code><code class="variable-string">sasl:DIGEST-MD5</code><code class="variable-quote">'</code><code class="variable-group">)</code></span>,
        <span class="sig-arg">tls_settings</span>=<span class="sig-default">None</span>,
        <span class="sig-arg">keepalive</span>=<span class="sig-default">0</span>,
        <span class="sig-arg">owner</span>=<span class="sig-default">None</span>)</span>
    <br /><em class="fname">(Constructor)</em>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream.__init__">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Initialize the ClientStream object.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>jid</code></strong> (: <a href="pyxmpp.jid.JID-class.html" class="link">pyxmpp.JID</a>) - : local JID.</li>
        <li><strong class="pname"><code>password</code></strong> (: <code class="link">unicode</code>) - : user's password.</li>
        <li><strong class="pname"><code>server</code></strong> (: <code class="link">unicode</code>) - : server to use. If not given then address will be derived form the JID.</li>
        <li><strong class="pname"><code>port</code></strong> (: <code class="link">int</code>) - : port number to use. If not given then address will be derived form the JID.</li>
        <li><strong class="pname"><code>auth_methods</code></strong> (: sequence of <code class="link">str</code>) - : sallowed authentication methods. SASL authentication mechanisms
in the list should be prefixed with &quot;sasl:&quot; string.</li>
        <li><strong class="pname"><code>tls_settings</code></strong> (: <a href="pyxmpp.streamtls.TLSSettings-class.html" class="link">pyxmpp.TLSSettings</a>) - : settings for StartTLS -- <a href="pyxmpp.streamtls.TLSSettings-class.html" class="link">TLSSettings</a> instance.</li>
        <li><strong class="pname"><code>keepalive</code></strong> (: <code class="link">int</code>) - : keepalive output interval. 0 to disable.</li>
        <li><strong class="pname"><code>owner</code></strong> - : <a href="pyxmpp.client.Client-class.html" class="link">Client</a>, <a href="pyxmpp.jabberd.component.Component-class.html" class="link">Component</a> or similar object &quot;owning&quot; this stream.</li>
    </ul></dd>
    <dt>Overrides:
        <a href="pyxmpp.xmlextra.StreamHandler-class.html#__init__">xmlextra.StreamHandler.__init__</a>
    </dt>
  </dl>
</td></tr></table>
</div>
<a name="_connect"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_connect</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">server</span>=<span class="sig-default">None</span>,
        <span class="sig-arg">port</span>=<span class="sig-default">None</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream._connect">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Same as <a href="pyxmpp.clientstream.ClientStream-class.html#connect" class="link">ClientStream.connect</a> but assume <a href="pyxmpp.stream.Stream-class.html#lock" class="link">self.lock</a> is acquired.
  <dl class="fields">
    <dt>Overrides:
        <a href="pyxmpp.streambase.StreamBase-class.html#_connect" onclick="show_private();">streambase.StreamBase._connect</a>
    </dt>
  </dl>
</td></tr></table>
</div>
<a name="_get_stream_features"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_get_stream_features</span>(<span class="sig-arg">self</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream._get_stream_features">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Include resource binding feature in the stream features list.</p>
<p>[server only]</p>
  <dl class="fields">
  </dl>
</td></tr></table>
</div>
<a name="_post_connect"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_post_connect</span>(<span class="sig-arg">self</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream._post_connect">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Initialize authentication when the connection is established
and we are the initiator.
  <dl class="fields">
    <dt>Overrides:
        <a href="pyxmpp.streambase.StreamBase-class.html#_post_connect" onclick="show_private();">streambase.StreamBase._post_connect</a>
    </dt>
  </dl>
</td></tr></table>
</div>
<a name="_reset"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_reset</span>(<span class="sig-arg">self</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream._reset">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Reset <a href="pyxmpp.clientstream.ClientStream-class.html" class="link">ClientStream</a> object state, making the object ready to handle
new connections.
  <dl class="fields">
    <dt>Overrides:
        <a href="pyxmpp.streambase.StreamBase-class.html#_reset" onclick="show_private();">streambase.StreamBase._reset</a>
    </dt>
  </dl>
</td></tr></table>
</div>
<a name="_try_auth"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_try_auth</span>(<span class="sig-arg">self</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream._try_auth">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Try to authenticate using the first one of allowed authentication
methods left.</p>
<p>[client only]</p>
  <dl class="fields">
  </dl>
</td></tr></table>
</div>
<a name="accept"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">accept</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">sock</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream.accept">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Accept an incoming client connection.</p>
<p>[server only]</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>sock</code></strong> - : a listening socket.</li>
    </ul></dd>
    <dt>Overrides:
        <a href="pyxmpp.streambase.StreamBase-class.html#accept">streambase.StreamBase.accept</a>
    </dt>
  </dl>
</td></tr></table>
</div>
<a name="check_authzid"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">check_authzid</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">authzid</span>,
        <span class="sig-arg">extra_info</span>=<span class="sig-default">None</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream.check_authzid">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Check authorization id provided by the client.</p>
<p>[server only]</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>authzid</code></strong> (: unicode) - : authorization id provided.</li>
        <li><strong class="pname"><code>extra_info</code></strong> (: mapping) - : additional information about the user
from the authentication backend. This mapping will
usually contain at least 'username' item.</li>
    </ul></dd>
    <dt>Returns: <code class="link">bool</code></dt>
        <dd><code class="link">True</code> if user is authorized to use that <code class="link">authzid</code>.</dd>
    <dt>Overrides:
        <a href="pyxmpp.sasl.core.PasswordManager-class.html#check_authzid">sasl.core.PasswordManager.check_authzid</a>
    </dt>
  </dl>
</td></tr></table>
</div>
<a name="choose_realm"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">choose_realm</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">realm_list</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream.choose_realm">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Choose authentication realm from the list provided by the server.</p>
<p>[client only]</p>
<p>Use domain of the own JID if no realm list was provided or the domain is on the list
or the first realm on the list otherwise.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>realm_list</code></strong> (: <code class="link">list</code> of <code class="link">unicode</code>) - : realm list provided by the server.</li>
    </ul></dd>
    <dt>Returns: <code class="link">unicode</code></dt>
        <dd>the realm chosen.</dd>
    <dt>Overrides:
        <a href="pyxmpp.sasl.core.PasswordManager-class.html#choose_realm">sasl.core.PasswordManager.choose_realm</a>
    </dt>
  </dl>
</td></tr></table>
</div>
<a name="connect"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">connect</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">server</span>=<span class="sig-default">None</span>,
        <span class="sig-arg">port</span>=<span class="sig-default">None</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream.connect">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Establish a client connection to a server.</p>
<p>[client only]</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>server</code></strong> (: <code class="link">unicode</code>) - : name or address of the server to use. Not recommended -- proper value
should be derived automatically from the JID.</li>
        <li><strong class="pname"><code>port</code></strong> (: <code class="link">int</code>) - : port number of the server to use. Not recommended --
proper value should be derived automatically from the JID.</li>
    </ul></dd>
    <dt>Overrides:
        <a href="pyxmpp.streambase.StreamBase-class.html#connect">streambase.StreamBase.connect</a>
    </dt>
  </dl>
</td></tr></table>
</div>
<a name="do_bind"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">do_bind</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">stanza</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream.do_bind">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Do the resource binding requested by a client connected.</p>
<p>[server only]</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>stanza</code></strong> (: <a href="pyxmpp.iq.Iq-class.html" class="link">pyxmpp.Iq</a>) - : resource binding request stanza.</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="fix_in_stanza"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">fix_in_stanza</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">stanza</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream.fix_in_stanza">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Fix an incoming stanza.</p>
<p>Ona server replace the sender address with authorized client JID.</p>
  <dl class="fields">
    <dt>Overrides:
        <a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#fix_in_stanza">stanzaprocessor.StanzaProcessor.fix_in_stanza</a>
    </dt>
  </dl>
</td></tr></table>
</div>
<a name="fix_out_stanza"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">fix_out_stanza</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">stanza</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream.fix_out_stanza">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Fix outgoing stanza.</p>
<p>On a client clear the sender JID. On a server set the sender
address to the own JID if the address is not set yet.</p>
  <dl class="fields">
    <dt>Overrides:
        <a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#fix_out_stanza">stanzaprocessor.StanzaProcessor.fix_out_stanza</a>
    </dt>
  </dl>
</td></tr></table>
</div>
<a name="get_password"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">get_password</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">username</span>,
        <span class="sig-arg">realm</span>=<span class="sig-default">None</span>,
        <span class="sig-arg">acceptable_formats</span>=<span class="sig-default"><code class="variable-group">(</code><code class="variable-quote">'</code><code class="variable-string">plain</code><code class="variable-quote">'</code><code class="variable-group">)</code></span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream.get_password">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Get a user password for the SASL authentication.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>username</code></strong> (: <code class="link">unicode</code>) - : username used for authentication.</li>
        <li><strong class="pname"><code>realm</code></strong> (: <code class="link">unicode</code>) - : realm used for authentication.</li>
        <li><strong class="pname"><code>acceptable_formats</code></strong> (: <code class="link">list</code> of <code class="link">str</code>) - : acceptable password encoding formats requested.</li>
    </ul></dd>
    <dt>Returns: (<code class="link">unicode</code>,`str`)</dt>
        <dd>The password and the format name ('plain').</dd>
    <dt>Overrides:
        <a href="pyxmpp.sasl.core.PasswordManager-class.html#get_password">sasl.core.PasswordManager.get_password</a>
    </dt>
  </dl>
</td></tr></table>
</div>
<a name="get_realms"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">get_realms</span>(<span class="sig-arg">self</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream.get_realms">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Get realms available for client authentication.</p>
<p>[server only]</p>
  <dl class="fields">
    <dt>Returns: <code class="link">list</code> of <code class="link">unicode</code></dt>
        <dd>list of realms.</dd>
    <dt>Overrides:
        <a href="pyxmpp.sasl.core.PasswordManager-class.html#get_realms">sasl.core.PasswordManager.get_realms</a>
    </dt>
  </dl>
</td></tr></table>
</div>
<a name="get_serv_host"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">get_serv_host</span>(<span class="sig-arg">self</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream.get_serv_host">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Get the service host name for SASL authentication.
  <dl class="fields">
    <dt>Returns:</dt>
        <dd>domain of the own JID.</dd>
    <dt>Overrides:
        <a href="pyxmpp.sasl.core.PasswordManager-class.html#get_serv_host">sasl.core.PasswordManager.get_serv_host</a>
    </dt>
  </dl>
</td></tr></table>
</div>
<a name="get_serv_name"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">get_serv_name</span>(<span class="sig-arg">self</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream.get_serv_name">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Get the service name for SASL authentication.
  <dl class="fields">
    <dt>Returns:</dt>
        <dd>domain of the own JID.</dd>
    <dt>Overrides:
        <a href="pyxmpp.sasl.core.PasswordManager-class.html#get_serv_name">sasl.core.PasswordManager.get_serv_name</a>
    </dt>
  </dl>
</td></tr></table>
</div>
<a name="get_serv_type"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">get_serv_type</span>(<span class="sig-arg">self</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.clientstream-pysrc.html#ClientStream.get_serv_type">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Get the server name for SASL authentication.
  <dl class="fields">
    <dt>Returns:</dt>
        <dd>'xmpp'.</dd>
    <dt>Overrides:
        <a href="pyxmpp.sasl.core.PasswordManager-class.html#get_serv_type">sasl.core.PasswordManager.get_serv_type</a>
    </dt>
  </dl>
</td></tr></table>
</div>
<br />
<!-- ==================== INSTANCE VARIABLE DETAILS ==================== -->
<a name="section-InstanceVariableDetails"></a>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Instance Variable Details</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-InstanceVariableDetails"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
</table>
<a name="my_jid"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <h3 class="epydoc">my_jid</h3>
  : requested local JID. Please notice that this may differ from
<a href="pyxmpp.stream.Stream-class.html#me" class="link">me</a>, which is actual authorized JID after the resource binding.
  <dl class="fields">
    <dt>Type:</dt>
      <dd>: <a href="pyxmpp.jid.JID-class.html" class="link">pyxmpp.JID</a></dd>
  </dl>
</td></tr></table>
</div>
<br />
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0.1 on Sun May  8 13:34:59 2011
    </td>
    <td align="right" class="footer">
      <a target="mainFrame" href="http://epydoc.sourceforge.net"
        >http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie();
  // -->
</script>
</body>
</html>
